Imports System.Net
Imports System.Net.Sockets
Imports System.IO


<ComClass()> _
Public Class NET_Sender
    Public Event MyEvent As EventHandler
    Dim ValidIP As New System.Text.RegularExpressions.Regex("[1-2]\d{1,2}\.[1-2]?\d{1,2}\.[1-2]?\d{1,2}\.[1-2]?\d{1,2}")
    Dim ClientIP As System.Net.IPAddress
    Dim TcpClient As System.Net.Sockets.TcpClient
    Dim NetWriter As System.IO.BinaryWriter
    Dim Config As System.Collections.Specialized.NameValueCollection

    Public Sub New()
        MyBase.new()
    End Sub

    Public Function Hello(Optional ByVal b As String = "")
        System.Windows.Forms.MessageBox.Show(b & vbCrLf & " : " & AppDomain.GetCurrentThreadId.ToString & _
        ". Thread Apartment State: " & System.Threading.Thread.CurrentThread.ApartmentState.ToString, "NET_Sender", Windows.Forms.MessageBoxButtons.OK, Windows.Forms.MessageBoxIcon.Information, Windows.Forms.MessageBoxDefaultButton.Button1, Windows.Forms.MessageBoxOptions.ServiceNotification)
    End Function

    Public Function Start()
        Config = System.Configuration.ConfigurationSettings.AppSettings
        If Config.Count = 0 Then
            Try
                System.Windows.Forms.MessageBox.Show(".    " & vbCrLf & _
                System.AppDomain.CurrentDomain.SetupInformation.ConfigurationFile & vbCrLf & _
                "  " & vbCrLf & _
                System.AppDomain.CurrentDomain.SetupInformation.ApplicationBase _
                , "NET_Sender", Windows.Forms.MessageBoxButtons.OK, Windows.Forms.MessageBoxIcon.Information, Windows.Forms.MessageBoxDefaultButton.Button1, Windows.Forms.MessageBoxOptions.ServiceNotification)
            Catch x As System.Exception
                Start = 1
            End Try
        Else
            If Len(Config("IP")) = 0 Or Len(Config("PORT")) = 0 Then
                Try
                    System.Windows.Forms.MessageBox.Show(".    " & vbCrLf & _
                    System.AppDomain.CurrentDomain.SetupInformation.ConfigurationFile & vbCrLf & _
                    "  " & vbCrLf & _
                    System.AppDomain.CurrentDomain.SetupInformation.ApplicationBase & vbCrLf & _
                    "  - ""IP""  ""PORT"" " _
                    , "NET_Sender", Windows.Forms.MessageBoxButtons.OK, Windows.Forms.MessageBoxIcon.Information, Windows.Forms.MessageBoxDefaultButton.Button1, Windows.Forms.MessageBoxOptions.ServiceNotification)
                Catch x As System.Exception
                    Start = 2
                End Try
            Else
                If ValidIP.IsMatch(Config("IP")) And Val(Config("PORT")) < 65535 Then
                    Try
                        TcpClient = New System.Net.Sockets.TcpClient()
                        ClientIP = IPAddress.Parse(Config("IP"))
                        Start = 0
                    Catch x As System.Exception
                        Start = 4
                    End Try
                Else
                    Try
                        System.Windows.Forms.MessageBox.Show(".    " & vbCrLf & _
                        System.AppDomain.CurrentDomain.SetupInformation.ConfigurationFile & vbCrLf & _
                        "  " & vbCrLf & _
                        System.AppDomain.CurrentDomain.SetupInformation.ApplicationBase & vbCrLf & _
                        "   - ""IP""  ""PORT"" " _
                        , "NET_Sender", Windows.Forms.MessageBoxButtons.OK, Windows.Forms.MessageBoxIcon.Information, Windows.Forms.MessageBoxDefaultButton.Button1, Windows.Forms.MessageBoxOptions.ServiceNotification)
                    Catch x As System.Exception
                        Start = 3
                    End Try
                End If
            End If
        End If
    End Function

    Public Function TCP_Connect()
        If TcpClient Is Nothing Then
            '   
            TCP_Connect = 1
        Else
            Try
                TcpClient.Connect(System.Net.IPAddress.Parse(Config("IP")), Val(Config("PORT")))
                Dim NetStream = TcpClient.GetStream               '   
                NetWriter = New System.IO.BinaryWriter(NetStream) ',    
                TCP_Connect = 0
            Catch x As System.Exception
                System.Windows.Forms.MessageBox.Show("    TCP/IP " & Config("IP") & ":" & Config("Port") & vbCrLf & _
                x.Message & vbCrLf & _
                " : " & AppDomain.GetCurrentThreadId.ToString & _
                ". Thread Apartment State: " & System.Threading.Thread.CurrentThread.ApartmentState.ToString _
                , "NET_Sender", Windows.Forms.MessageBoxButtons.OK, Windows.Forms.MessageBoxIcon.Information, Windows.Forms.MessageBoxDefaultButton.Button1, Windows.Forms.MessageBoxOptions.ServiceNotification)
                TCP_Connect = 1
            End Try
        End If
    End Function

    Public Function TCP_Write(Optional ByVal Value As Int32 = 0)
        If NetWriter Is Nothing Then
            '   
            TCP_Write = 1
        Else

            Try
                NetWriter.Write(Value)
                TCP_Write = 0
            Catch x As System.Exception
                MsgBox("    TCP/IP " & Config("IP") & ":" & Config("Port") & vbCrLf & _
                x.Message & vbCrLf & _
                " : " & AppDomain.GetCurrentThreadId.ToString & _
                ". Thread Apartment State: " & System.Threading.Thread.CurrentThread.ApartmentState.ToString)
                TCP_Write = 1
            End Try
        End If
    End Function

    Public Sub Abort()
        If TcpClient Is Nothing Then
        Else
            TcpClient.Close()
            TcpClient = Nothing
        End If
        If NetWriter Is Nothing Then
        Else
            NetWriter.Close()
            NetWriter = Nothing
        End If
    End Sub
End Class

